(function($) {
    window.pmSearch = window.pmSearch || {};
    let search = window.pmSearch;

    search.init = function() {
        // init key
        search.getApiKey();
        search.timers = {};
        search.selected = {};

        search.wrapper = $('<div class="pm-tools-search-wrapper hide-form"><div class="search-form"><input type="text" /><ul class="found"></ul></div></div>');
        search.input = search.wrapper.find('input');
        search.found = search.wrapper.find('.found');

        $('#wrapper').append(search.wrapper);

        $('body').bind('keydown', function(event) {
            if (search.wrapper.hasClass('hide-form') &&
                (event.altKey === true && (event.keyCode === 68 || event.keyCode === 206))) {
                search.showForm();
                event.preventDefault();
            }
            else if(!search.wrapper.hasClass('hide-form')) {
                if(event.keyCode === 27 || (event.altKey === true && (event.keyCode === 68 || event.keyCode === 206))) {
                    search.closeForm();
                    event.preventDefault();
                }
            }
        });
        search.input.on('keyup', function() {
            let $this = $(this);
            if (search.timers.change) {
                clearTimeout(search.timers.change);
            }

            search.timers.change = setTimeout(function () {
                search.searchValue($this.val());
            }, 100);
        });
    };

    search.showForm = function() {
        search.input.val('');
        search.found.html('');
        search.wrapper.removeClass('hide-form');
        search.input.focus();
    };
    search.closeForm = function() {
        search.wrapper.addClass('hide-form');
    };

    search.searchValue = function(searchText) {
        if (searchText !== '') {
            searchText = searchText.replace(' ', '+');
            let key = search.getApiKey();

            if (key) {
                $.ajax({
                    url: "https://pm.i20.biz/issues.json?limit=10&subject=~" + searchText,
                    data: {"": key},
                    dataType: 'json',
                    beforeSend: function(xhr){xhr.setRequestHeader('X-Redmine-API-Key', key);},
                    success: function (data) {
                        if (data && data.total_count) {
                            search.found.html('');
                            data.issues.forEach(function(element) {
                                let issue = $('<li><a href="https://pm.i20.biz/issues/' + element.id + '">'
                                    + '<div class="found-issue">'
                                    + element.subject
                                    +'</div>'
                                    + '</a></li>'
                                )
                                search.found.append(issue);
                            });
                        }
                    },
                    async: true
                })
            }
        }
    }

    search.getApiKey = function() {
        if (typeof search.apiKey == 'undefined') {
            chrome.storage.sync.get('apiKey', function(value) {search.apiKey = value.apiKey });
        }
        return search.apiKey;
    }

    search.init();

})(jQuery);
